using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.IO;


namespace YIOConnector
{
	class YIOConnector
	{
		static void ReadRemoteOutput( object sro )
		{
			StreamReader sr = (StreamReader)sro;
			try {
				char ch;
				int i;
				while( ( i = sr.Read() ) != -1 ) {
					ch = (char)i;
					Console.Write( ch );
				}
			} catch {
			}
		}
		static void Main( string[] args )
		{
			if( args.Length < 3 ) {
				Console.WriteLine( "Invalid argument number for starting process" );
			}
			IPHostEntry ipHostEntry = null;
			try {
				ipHostEntry = Dns.GetHostEntry( args[0] );
			} catch( SocketException ske ) {
				Console.WriteLine( ske.Message );
				Environment.Exit( 1 );
			} catch( Exception exc ) {
				Console.WriteLine( exc.Message );
				Environment.Exit( 1 );
			}
			IPHostEntry ipHostEntryLocal = Dns.GetHostEntry( "localhost" );
			if( ipHostEntryLocal.HostName.Equals( ipHostEntry.HostName ) ) {
			// if( false ) {
				Process p = new Process();
				p.StartInfo.FileName = args[2];
				int i = 3;
				p.StartInfo.Arguments = "";
				for( i = 3; i < args.Length; i++ ) {
					p.StartInfo.Arguments += args[i] + " ";
				}
				Console.WriteLine( "{0} {1}", p.StartInfo.FileName, p.StartInfo.Arguments );
				p.StartInfo.UseShellExecute = false;
				p.Start();
				p.WaitForExit();
				return;
			} else {
				int nPort;
				nPort = Int32.Parse( args[1] );
				TcpClient tClient = new TcpClient( ipHostEntry.HostName, nPort );
				NetworkStream ns = tClient.GetStream();
				StreamReader sr = new StreamReader( ns );
				StreamWriter sw = new StreamWriter( ns );
				string strRes = null;
				sw.WriteLine( "start" );
				sw.Flush();
				strRes = sr.ReadLine();
				if( strRes == null ) {
					Console.WriteLine( "Error starting process on {0}", ipHostEntry.HostName );
					Environment.Exit( 1 );
				}
				if( strRes.Contains( "filename and argument, please" ) ) {
					string strArgs = "";
					int i;
					for( i = 2; i < args.Length; i++ ) {
						strArgs += args[i] + " ";
					}
					sw.WriteLine( strArgs );
					sw.Flush();
					Thread th = new Thread( new ParameterizedThreadStart( ReadRemoteOutput ) );
					th.Start( sr );
					try {
						while( true ) {
							string str = Console.ReadLine();
							sw.WriteLine( str );
							sw.Flush();
						}
					} catch {
					}
				}
			}
		}
	}
}
